extends RigidBody2D
#Proverbs 1:7
#The fear of the LORD is the beginning of knowledge: but fools
#despise wisdom and instruction.

##VARIABLES
#Movement
var vel = Vector2()
var speed = 500
#change height
export var floors = PoolVector2Array([Vector2(0,0)])
var current_floor = 0
var is_floor_changed = false #This is used because intergrated forces are overriding the change floor
#Beat
enum BEAT_TYPES {BLUE,GREEN,PURPLE,YELLOW} 
var beat = BEAT_TYPES.BLUE

##Floor handling
func change_floor(is_up):#True is up, false is down.
	if(is_up):
		if(current_floor > 0):
			current_floor -= 1
		else:
			current_floor = floors.size()-1
	else:
		if(current_floor+1 < floors.size()):
			current_floor += 1
		else:
			current_floor = 0

	global_transform.origin.y = floors[current_floor].y
	is_floor_changed = true

#Beat handling
func change_beat(value):
	beat = value
	var modell = get_node("model")
	match(value):
		BEAT_TYPES.GREEN:
			modell.modulate = Color("00ff00")
		BEAT_TYPES.BLUE:
			modell.modulate = Color("0000ff")
		BEAT_TYPES.PURPLE:
			modell.modulate = Color("ff00ff")
		BEAT_TYPES.YELLOW:
			modell.modulate = Color("ffff00")


##MAIN
func _input(event):
	if(event.is_action_pressed("ui_left")):
		vel.x = -speed
		change_beat(BEAT_TYPES.GREEN)
	if(event.is_action_pressed("ui_right")):
		vel.x = speed
		change_beat(BEAT_TYPES.BLUE)
	if((event.is_action_released("ui_left") && (vel.x == -speed))||(event.is_action_released("ui_right") && (vel.x == speed))):
		vel.x = 0
	
	if(event.is_action_pressed("ui_up")):
		change_floor(true)
		change_beat(BEAT_TYPES.PURPLE)
	if(event.is_action_pressed("ui_down")):
		change_floor(false)
		change_beat(BEAT_TYPES.YELLOW)

func _integrate_forces(state):
	vel.y = linear_velocity.y
	linear_velocity = vel

	if(is_floor_changed):#change the floor
		global_transform.origin.y = floors[current_floor].y
		is_floor_changed = false

func _on_area_enter(area):
	var gp = area.get_parent().get_parent()
	if(gp.beat == beat):
		get_node("/root/hud").update_score(gp.score)
	else:
		get_node("/root/hud").update_health(gp.damage)
	gp.queue_free()

	#inform game.gd
	get_parent()._check_enemies()

func _on_area_exit(area):
	pass

func _ready():
	get_node("colid/area").connect("area_entered",self,"_on_area_enter")
	get_node("colid/area").connect("area_exited",self,"_on_area_exit")