extends RigidBody2D

#Ecclesiastes 1:17-18
#And I gave my heart to know wisdom, and to know madness
#and folly: I perceived that this also is vexation of spirit.
#18
#For in much wisdom is much grief: and he that increaseth
#knowledge increaseth sorrow.

#Enemy data
export var score = 15
export var damage = 55
enum SUBCLASS {NORMAL,TURRENT,BULLET,GHOST}
export(SUBCLASS) var subcal = 0
#Turrent
export var fire_delay = 1.2
export(bool) var is_firing = true#Used for cutting boss fire.
#beat
enum BEAT_TYPES {BLUE,GREEN,PURPLE,YELLOW} 
export(BEAT_TYPES) var beat = BEAT_TYPES.BLUE

#Turrent
func _fire_gun():
	if(is_firing):
		var bul = load("res://objects/enemy/bullet.tscn").instance()
		bul.global_transform = get_node("model2/bul_spawn").global_transform
		bul.beat = beat
		get_parent().get_parent().add_child(bul)
		bul.reload_beat()

func reload_beat():
	var modell = get_node("model")
	match(beat):
		BEAT_TYPES.GREEN:
			modell.modulate = Color("00ff00")
		BEAT_TYPES.BLUE:
			modell.modulate = Color("0000ff")
		BEAT_TYPES.PURPLE:
			modell.modulate = Color("ff00ff")
		BEAT_TYPES.YELLOW:
			modell.modulate = Color("ffff00")

func _integrate_forces(state):
	match(subcal):
		SUBCLASS.TURRENT:
			if(get_parent().get_parent().has_node("char")):#Rotate turrent
				get_node("model2").look_at(get_parent().get_parent().get_node("char").global_transform.origin)
		SUBCLASS.GHOST:
			if(get_parent().get_parent().has_node("char")):#Rotate turrent
				look_at(get_parent().get_parent().get_node("char").global_transform.origin)

func _process(delta):
	move_local_x(1)

func _ready():
	match(subcal):
		SUBCLASS.TURRENT:
			var time = Timer.new()
			time.wait_time = fire_delay
			time.connect("timeout",self,"_fire_gun")
			add_child(time)
			time.start()
			set_process(false)
		SUBCLASS.BULLET:
			var time = Timer.new()
			time.wait_time = fire_delay
			time.connect("timeout",self,"queue_free")
			add_child(time)
			time.start()
			set_process(true)
		SUBCLASS.GHOST:
			set_process(true)
		_:
			set_process(false)#Only bullets and ghosts use this
	reload_beat()